<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 99</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 99: relecture du papier 13</H1>

<P>
Numéro du papier: 13

<P>Nom du papier et auteurs: 
"Pattern Matching en Java"
Rémi Forax, Gilles Roussel

<H2>1</H2>

<P>
Nom du rapporteur: Manuel Serrano

<P>Confiance en la note: 2

<P>Notation du papier: 2

<P>Commentaires aux auteurs:

<P>Le premier reproche que je fais à cet article est qu'il ne convient
pas aux Jfla. Le lien avec les langages applicatifs est vraiment très
faible. La seule proximité apparente est que l'article propose une
implantation, en Java, d'un trait familier de ML. Le lien est très
faible parce que, justement, le filtrage (mot français pour traduire
l'expression anglaise "pattern matching"), n'est pas exclusivement
présent dans les langages fonctionnels. Par exemple, modula-3
proposait déjà du filtrage. La faiblesse de ce lien est assez apparent
dans l'article parce que la grande majorité de l'article consiste à
montrer comment il faut jongler avec les constructions de Java pour
parvenir à faire du filtrage (filtrage, qui je le répète n'est pas
l'exclusivité des langages fonctionnels).
<P>
Par ailleurs, je trouve la lecture de l'article assez difficile. En
fait, l'article s'adresse à des spécialistes (ou à défaut à des
utilisateurs) du langage Java et pas à des gens habitués aux langages
fonctionnels. Les nombreuses références aux "design pattern" sont, je
trouve assez arides.
<P>
L'intérêt du filtrage dans les langages comme ML est à mon sens double:
<P> 1- c'est une construction très "visuelle", le filtre ressemble à 
    l'expression qu'il faudrait écrire pour construire la valeur filtrée
<P> 2- on sait implanter très efficacement les constructions de filtrage

<P>Ces deux avantages sont totalement ignorés par l'article qui
s'intéresse au filtrage pour le filtrage. Puisque la référence
explicite de l'article est ML alors il manque, au moins en conclusion,
une comparaison en terme d'expressivité (par exemple le filtrage de ML
permet les constantes, pas celui présenté dans l'article) et
d'efficacité.
<P>
Au delà de ces remarques générales, et en jouant le jeu d'une lecture
avec un regard de "fonctionnel", voici quelques autres remarques plus
ponctuelles:
<P>
<PRE>
Résumé:
-------
Ligne 2: fonctionels -> fonctionnels.
Par ailleurs, si, comme je l'ai déjà dit, le filtrage ne se trouve
pas uniquement dans les langages fonctionnels, il ne se trouve certainement
pas que dans les langages fonctionnels strictement typés (cf.
le livre de C. Queinnec entièrement consacré au filtrage). 

1. Introduction:
----------------
Paragraphe 2: "Nous montrons que cette implémentation...que la méthode
classique". De quoi s'agit il ? En quoi consiste la méthode classique ?

2. Les types récursifs:
-----------------------

Je ne suis pas d'accord avec le premier exemple. Visiblement je ne comprends
pas très bien le but de l'article. S'il s'agit de simuler des type
récursifs « à la ML » alors ce premier exemple est faux car il permet
de construire des listes hétérogènes, ce que ne permet pas ML mais ce que
permet Scheme. En effet, avec le schéma proposé, il est possible d'écrire
le prgm suivant:

-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----
abstract class List {}

class Nil extends List {}

class Cons extends List {
   public Cons( int value, List tail ) {
      this.value = value;
      this.tail = tail;
   }
   List tail;
   int value;
}

class ECons extends List {
   public ECons( double value, List tail ) {
      this.value = value;
      this.tail = tail;
   }
   List tail;
   double value;
}


class foo {
   public static void main( String[] args ) {
      Nil n = new Nil();
      ECons ec = new ECons( 4.5, n );
      Cons c = new Cons( 4, ec );

      System.out.println( c );
   }
}
-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----

J'ai l'impression qu'il faut spécifier la classe Cons comme:

-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----
class Cons extends List {
   public Cons( int value, Cons tail ) {
      this.value = value;
      this.tail = tail;
   }
   Cons tail;
   int value;
}
-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----

Mais je ne sais pas si ce schéma ci est compatible avec le reste de l'exposé.

Les types abstraits:
--------------------
Phrase 1: je pense qu'il faudrait développer un peu plus l'argument. Car
sur l'exemple présent il me semble assez faible. En effet, on est en
train de parler de listes d'entiers (le type int est figé dans la classe
Cons) ! Dans ce contexte, figer l'accès aux attributs ne me semble pas 
très important...

Page 3, class LazyCons: il y a deux versions de la méthode getTail().

Il manque un verbe dans la phrase "Par exemple, de définir l'ensemble...".
Je ne comprends d'ailleurs pas cette remarque. Pourquoi est-ce qu'on ne
peut pas faire exactement la même chose sans utiliser d'interface
(c'est bien de cela qu'il s'agit ici interface vs. classe).


Page 4: "En effet, il est nécessaire d'utiliser le transtypage et ..."
J'avoue ma grande faute mais je ne sais pas ce qu'est le
transtypage. Du coup je ne comprends rien à l'exemple montré en
dessous. Peut-être que quelques explications supplémentaires seraient
ici utiles ?

Page 5: "Nous venons de voir que l'encapsulation..."
Il doit s'agir encore ici de mon incompréhension de l'exemple précédent
mais il n'a jamais été question jusqu'à présent d'encapsulation (du moins
explicitement), peut-être faudrait il quelques explications supplémentaires ?

Approche fonctionnelles/Visitor:
--------------------------------
Je pense qu'il faut détailler pourquoi l'approche fonctionnelle ne
marche pas, en donnant plus de code. En effet, lors d'une première lecture
je n'arrivais pas à voir la différence entre:

-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----
class PatternMatcher {
   public final Object match( Nil n ) {...}
   public final Object match( Cons c) {...}
}
-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----
et
-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----
class SumVisitor implements Visitor {
   int sum = 0;
   public final void visit(Nil n ) {}
   public final void visit(Cons c) {
      sum += ...
      c.tail.accept(this);
   }
}
-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|-----

Je ne voyais pas la différence parce que justement elle n'est pas visible.
Elle est dans le ... de la seconde méthode match de la classe PatternMatcher ! 


Page 9: je ne trouve pas ces mesures de performances très
probantes. Je suis même surpris qu'il n'y ait qu'un facteur 8 entre le
PatternMatcher et le PatternMatcher optimisé. La version qui recherche
les méthodes par leur noms, est purement et simplement irréaliste (on
croirait presque du Tcl) alors, dans ce contexte, ne gagner qu'un
facteur 8 n'est pas grand chose.

Page 12: unique paragraphe. Je ne comprends pas du tout ce paragraphe.
Je crois qu'il faut soit en dire plus soit supprimer la section.

Page 13 et Page 14: je me demande si quelques explications du code
présenté ne seraient pas utiles.  Il y a là plus d'une page entière de
code qui est à peine exploitée. La lecture de ces sections est du coup
un peu rebutante.
</PRE>

<P>
Commentaires réservés au comité de programme:
<P>
L'apport de cet article me semble vraiment très limité. Pour ce que j'en 
comprends, il s'agit principalement d'applications et d'adaptations de 
"design pattern". Je ne comprends pas très bien quelle pourrait être
la place d'un article comme celui-ci dans une conférence sur les
langages fonctionnels ! Par ailleurs, l'apport personnel des auteurs
n'est pas très clair non plus. On ne comprends pas très bien ce qu'il
y a de novateur. Il m'a un peu semblé que l'article présente l'emploi
et le réglage des techniques connues pour une instance d'un problème
particulier.


<H2>2</H2>

<P>
Nom du rapporteur: Laurent Dami

<P>Confiance en la note: (de 1 à 3) 3
<P> (1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.)

<P>Notation du papier: (de 1 à 5) 2
<P> (1: à rejeter; 2: inintéressant; 3: acceptable;
<P>  4: bon papier; 5: très bon papier)

<P>Commentaires aux auteurs:


<P>Le papier propose plusieurs schémas de conception pour tenter
d'approcher le "pattern matching" des langages fonctionnels en
Java. Les solutions avancées sont bien décrites, mais semblent lourdes
à mettre en oeuvre par rapport au but recherché; dans des situations
concrètes je doute fort qu'un programmeur soit disposé à suivre une
telle méthodologie, et les bénéfices qu'il en retirerait ne sont pas
évidents à dégager. Il s'agit là d'une appréciation très subjective,
mais il y a d'autres points problématiques dans le papier.

<P>Le niveau du discours n'est pas assez élevé: le lecteur plonge
immédiatement dans la "solution", sans que le problème initial soit
discuté suffisamment en profondeur. Le papier ne donne pas assez
d'éléments pour convaincre que le pattern matching est souhaitable
dans un monde objet. En fait, on pourrait dire que le pattern matching
est directement opposé à la philosophie objet, puisqu'il requiert la
visibilité de la structure interne, alors que les objets cherchent à
la cacher. Néanmoins divers auteurs se sont posés la question. Je
recommande en tout cas le papier
<BLOCKQUOTE>
        William Cook
        Object-Oriented Programming versus Abstract Data Types.
        Foundations of Object-Oriented Languages, pp 151-178
        Lecture Notes in Comp. Sc 489, Springer-Verlag, 1990.
</BLOCKQUOTE>

<P>qui expose très clairement le dilemne entre les deux philosophies.  Il
y a également d'autres travaux dont malheureusement je n'ai plus les
références précises: sauf erreur un papier de Phil Wadler sur le
pattern matching, diverses publications de Giuseppe Castagna sur le
multiple dispatch, et le papier de Cardelli, Pierce, Bruce, Castagna,
Leavens, Smith sur les "multi-methods" (Journal of Object-Oriented
Programming). En tous les cas il manque ici une section avec pointeurs
sur la littérature, recherches antérieures et état de l'art.
De plus les exemples, basés sur des traitements de listes, sont mal
choisis, car il existe plusieurs idiomes dans le monde OO (par exemple
les "itérateurs") qui traitent ce genre de cas de manière élégante.

<P>Quelques autres remarques en vrac:

<PRE>
pppp1: cette étude aboutie - aboutit
p3 bas: abstract class Cons - je ne comprends pas l'intérêt de la
        classe abstraite ici. A quoi ressemblerait la sous-classe 
        concrète?
p8: le nom "match" est mal choisi, puisqu'il s'agit ici de la méthode
qui implémente le "merge". Par ailleurs on voit très clairement que
cette démarche introduit une explosion combinatoire des cas à traiter,
et qu'il ne s'agit pas du même phénomène de matching que dans ML.

p9: "effectue une unification". Formellement, une unification génère
un ensemble de substitutions. Ce n'est pas du tout ce qui se passe
ici.
</PRE>

</BODY>
</HTML>
